# -*- coding: utf-8 -*-
from setuptools import setup

packages = \
['odd_collector',
 'odd_collector.adapters',
 'odd_collector.adapters.airbyte',
 'odd_collector.adapters.airbyte.mappers',
 'odd_collector.adapters.cassandra',
 'odd_collector.adapters.cassandra.mappers',
 'odd_collector.adapters.clickhouse',
 'odd_collector.adapters.clickhouse.domain',
 'odd_collector.adapters.clickhouse.mappers',
 'odd_collector.adapters.clickhouse.mappers.integrated_engines',
 'odd_collector.adapters.cubejs',
 'odd_collector.adapters.cubejs.domain',
 'odd_collector.adapters.cubejs.mappers',
 'odd_collector.adapters.dbt',
 'odd_collector.adapters.dbt.mappers',
 'odd_collector.adapters.druid',
 'odd_collector.adapters.druid.domain',
 'odd_collector.adapters.druid.mappers',
 'odd_collector.adapters.elasticsearch',
 'odd_collector.adapters.elasticsearch.mappers',
 'odd_collector.adapters.feast',
 'odd_collector.adapters.feast.mappers',
 'odd_collector.adapters.hive',
 'odd_collector.adapters.hive.grammar_parser',
 'odd_collector.adapters.hive.mappers',
 'odd_collector.adapters.hive.models',
 'odd_collector.adapters.kafka',
 'odd_collector.adapters.kafka.mappers',
 'odd_collector.adapters.kafka.mappers.parser',
 'odd_collector.adapters.kubeflow',
 'odd_collector.adapters.kubeflow.mappers',
 'odd_collector.adapters.metabase',
 'odd_collector.adapters.metabase.domain',
 'odd_collector.adapters.metabase.mappers',
 'odd_collector.adapters.metabase.tests.mappers',
 'odd_collector.adapters.mlflow',
 'odd_collector.adapters.mlflow.domain',
 'odd_collector.adapters.mlflow.mappers',
 'odd_collector.adapters.mode',
 'odd_collector.adapters.mode.domain',
 'odd_collector.adapters.mode.mappers',
 'odd_collector.adapters.mongodb',
 'odd_collector.adapters.mongodb.mappers',
 'odd_collector.adapters.mssql',
 'odd_collector.adapters.mssql.mappers',
 'odd_collector.adapters.mssql.models',
 'odd_collector.adapters.mysql',
 'odd_collector.adapters.mysql.mappers',
 'odd_collector.adapters.neo4j',
 'odd_collector.adapters.neo4j.mappers',
 'odd_collector.adapters.odbc',
 'odd_collector.adapters.odbc.domain',
 'odd_collector.adapters.odbc.mappers',
 'odd_collector.adapters.odbc.repository',
 'odd_collector.adapters.odd_adapter',
 'odd_collector.adapters.oracle',
 'odd_collector.adapters.oracle.domain',
 'odd_collector.adapters.oracle.mappers',
 'odd_collector.adapters.oracle.repository',
 'odd_collector.adapters.postgresql',
 'odd_collector.adapters.postgresql.mappers',
 'odd_collector.adapters.presto',
 'odd_collector.adapters.presto.mappers',
 'odd_collector.adapters.presto.tests',
 'odd_collector.adapters.redash',
 'odd_collector.adapters.redash.domain',
 'odd_collector.adapters.redash.mappers',
 'odd_collector.adapters.redshift',
 'odd_collector.adapters.redshift.mappers',
 'odd_collector.adapters.singlestore',
 'odd_collector.adapters.singlestore.mappers',
 'odd_collector.adapters.snowflake',
 'odd_collector.adapters.snowflake.domain',
 'odd_collector.adapters.snowflake.map',
 'odd_collector.adapters.superset',
 'odd_collector.adapters.superset.domain',
 'odd_collector.adapters.superset.mappers',
 'odd_collector.adapters.superset.tests',
 'odd_collector.adapters.tableau',
 'odd_collector.adapters.tableau.domain',
 'odd_collector.adapters.tableau.mappers',
 'odd_collector.adapters.tableau.tests',
 'odd_collector.adapters.tarantool',
 'odd_collector.adapters.tarantool.mappers',
 'odd_collector.adapters.trino',
 'odd_collector.adapters.vertica',
 'odd_collector.adapters.vertica.domain',
 'odd_collector.adapters.vertica.mapper',
 'odd_collector.adapters.vertica.tests',
 'odd_collector.domain',
 'odd_collector.domain.rest_client',
 'odd_collector.helpers']

package_data = \
{'': ['*']}

install_requires = \
['boto3==1.26.32',
 'cassandra-driver==3.25.0',
 'clickhouse-driver==0.2.3',
 'confluent-kafka==1.9.2',
 'elasticsearch==7.14.0',
 'fastavro>=1.7.1,<2.0.0',
 'feast==0.26.0',
 'flatdict==4.0.1',
 'funcy==1.17',
 'hive-metastore-client==1.0.9',
 'lark-parser==0.11.1',
 'llvmlite>=0.39.1,<0.40.0',
 'mlflow==2.0.1',
 'more-itertools==8.13.0',
 'mysql-connector-python==8.0.28',
 'neo4j==4.3.7',
 'numba>=0.56.4,<0.57.0',
 'odd-collector-sdk==0.3.11',
 'odd-models==2.0.10',
 'oddrn-generator>=0.1.67,<0.2.0',
 'oracledb==1.2.1',
 'presto-python-client==0.8.2',
 'psycopg2-binary==2.9.3',
 'pyaml-env>=1.2.1,<2.0.0',
 'pyhumps==3.0.2',
 'pymongo[srv]==4.0.2',
 'pymssql==2.2.5',
 'pyodbc==4.0.35',
 'pytest-asyncio>=0.20.3,<0.21.0',
 'pytest==7.1.2',
 'pytz>=2022.7,<2023.0',
 'snowflake-connector-python==2.8.1',
 'sql-metadata>=2.6.0,<3.0.0',
 'sqlalchemy>=1.4.45,<2.0.0',
 'tableauserverclient==0.19.0',
 'tarantool==0.8.0',
 'trino==0.315.0',
 'vertica-python==1.1.1']

setup_kwargs = {
    'name': 'odd-collector',
    'version': '0.1.18',
    'description': 'ODD Collector',
    'long_description': 'None',
    'author': 'Open Data Discovery',
    'author_email': 'pypi@opendatadiscovery.org',
    'maintainer': 'None',
    'maintainer_email': 'None',
    'url': 'https://github.com/opendatadiscovery/odd-collector',
    'packages': packages,
    'package_data': package_data,
    'install_requires': install_requires,
    'python_requires': '>=3.9.1,<4.0.0',
}


setup(**setup_kwargs)
